﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using Microsoft.AspNetCore.Http;
@model CyberaniumModels.ProcessesAssign
@{
    ViewData["Title"] = "Index";
}
@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]');
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]');
    </script>
}
<script src="~/Script/Master/Layout.js"></script>
<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        });
        if ($('#Id').val() > 0) {
            showForm()
            GetFunctionsByOrgId($('#Id').val(), 0);
        }
    });
</script>
<script src="~/Script/Master/Layout.js"></script>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Processes List</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line" id="dvForm">
                        <form asp-area="ApplicationManagement" asp-controller="Assesment" asp-action="SubmitAssesment" id="form" method="post"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/ProcessesAssign/Index');"
                              data-ajax-failure="Errmsg(data);">
                            @Html.HiddenFor(m => m.Id)
                            <div class="pb-2 mt-4 mb-2 border-bottom box_title">
                                Process Dashboard
                            </div>
                            <div class="row">
                                <div class="col-12 text-center">
                                    <label>Select Organization Type</label>
                                    <div class="select_box m_bottom">
                                        <label class="radio-inline">
                                            <input type="radio" name="Organization" value="0" onclick="ManageOrganizationDiv(this)" checked>Parent Organization
                                        </label>
                                        <label class="radio-inline">
                                            <input type="radio" name="Organization" value="1" onclick="ManageOrganizationDiv(this)">Child Organization
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <div class="mb-2 border-bottom box_title"></div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12" style="display:none;" id="divChildOrg">
                                    <label>Child Company</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.ChildOrgId, Model.DdlChildOrg, "Select Child Company", new { @class = "form-control m_no", onchange = "GetFunctionsByOrgId($('#Id').val(),$(this).val());" })
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Function</label>
                                    <div class="select_box m_bottom">
                                        <select class="form-control m_no" asp-for="FunctionId" onchange="GetProcessesByFunctionId(this)"><option value="0">Select Function</option></select>
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12" style="display:none;" id="divDdlProcess">
                                    <label>Processes</label>
                                    <div class="select_box m_bottom">
                                        <select class="form-control m_no" id="ddlProcess" onchange="GetDCEnablerScore(this)"><option value="0">Select Function</option></select>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-4 col-sm-6 col-xs-12 details_process" style="display:none">
                                    <label>Processes Consultant</label>
                                    <div class="select_box m_bottom">
                                        <input class="form-control m_no" value="@Context.Session.GetString("UserName")" readonly />
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12 details_process" style="display:none">
                                    <label>Process Description</label>
                                    <div class="select_box m_bottom">
                                        <textarea class="form-control m_no" id="ProDes" style="height:70px" readonly></textarea>
                                    </div>
                                </div>
                            </div>
                            <div id="DCScore" style="display:none;">
                                <div class="pb-2 mt-4 mb-2 border-bottom box_title">Domain Criticality Score</div>
                                <div class="row">
                                    <div class="col-12">
                                        <div class="table_control">
                                            <table id="DomainCritical" class="table">
                                                <thead>
                                                    <tr>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                                <script>
                                    function getPrivacyValue(input) {
                                        var value = 0;
                                        $('.Privacy').each(function (i, ele) {
                                            value += parseInt($(this).val())
                                        });
                                        $('#PrivacyAverage').val(value / $('.DC').length);
                                        $('#PrivacyAverage').trigger('change');
                                    }
                                    function getAvailabilityValue(input) {
                                        var value = 0;
                                        $('.Availability').each(function (i, ele) {
                                            value += parseInt($(this).val())
                                        });
                                        $('#AvailabilityAverage').val(value / $('.DC').length);
                                        $('#AvailabilityAverage').trigger('change');
                                    }
                                    function getDIValue(input) {
                                        var value = 0;
                                        $('.DI').each(function (i, ele) {
                                            value += parseInt($(this).val())
                                        });
                                        $('#DIAverage').val(value / $('.DC').length);
                                        $('#DIAverage').trigger('change');
                                    }
                                    function getCSValue(input) {
                                        var value = 0;
                                        $('.CS').each(function (i, ele) {
                                            value += parseInt($(this).val())
                                        });
                                        $('#CSAverage').val(value / $('.DC').length);
                                        $('#CSAverage').trigger('change');
                                    }
                                    function getDCValue(input) {
                                        var value = 0;
                                        $('.DC').each(function (i, ele) {
                                            value += parseInt($(this).val())
                                        });
                                        $('#DCAverage').val(value / $('.DC').length);
                                        $('#DCAverage').trigger('change');
                                    }
                                </script>
                            </div>
                            <div id="EnablerScore" style="display:none;">
                                <div class="pb-2 mt-2 mb-2 border-bottom box_title">
                                    Enabler Score
                                </div>
                                <div class="row">
                                    <div class="col-12">
                                        <div class="table_control" id="divEnablerScore">
                                            <script>
                                                function showForm() {
                                                    $('#dvDataTable').hide();
                                                    $('#dvForm').removeAttr('class');
                                                }
                                                function hideForm() {
                                                    $('#dvDataTable').show();
                                                    $('#dvForm').attr('class', 'service_line');
                                                }
                                                function ManageOrganizationDiv(checkbox) {
                                                    var val = parseInt($(checkbox).val());
                                                    if (val > 0) {
                                                        $('#divChildOrg').show();
                                                        $(".details_process").hide();
                                                        $('#FunctionId').html('<option value="0">Select Function</option>');
                                                        $("#ddlProcess").html('<option value="0">Select Process</option>');
                                                    } else {
                                                        $('#divChildOrg').hide();
                                                        $('#divDdlProcess').hide();
                                                        $(".details_process").hide();
                                                        GetFunctionsByOrgId($('#Id').val(), 0);
                                                        $('#divChildOrg').find('option:eq(0)').prop('selected', true);
                                                    }
                                                    $(".details_process").hide();
                                                }
                                                function GetFunctionsByOrgId(parentOrgId, childOrgId) {
                                                    $("#divDdlProcess").hide();
                                                    $(".details_process").hide();
                                                    $('#FunctionId').empty();
                                                    $.get('/ApplicationManagement/ProcessEnabler/GetFunctionsByOrgId', { parentOrgId: parentOrgId, childOrgId: childOrgId }, function (data) {
                                                        var html = '<option value="0">Select Function</option>';
                                                        $.each(data, function (i, item) {
                                                            html += '<option value="' + item.id + '">' + item.functionName + '</option>'
                                                        })
                                                        $('#FunctionId').html(html);
                                                    });
                                                }
                                                function GetProcessesByFunctionId(process) {
                                                    var functionId = parseInt($(process).val());
                                                    if (functionId > 0) {
                                                        $.get('/ApplicationManagement/FunctionDashboard/GetProcesses', { functionId: functionId }, function (res) {
                                                            $('#ddlProcess').empty();
                                                            var html = '<option value="0">Select Process</option>';
                                                            $.each(res, function (i, v) {
                                                                html += '<option value="' + v.id + '" id="' + v.description + '">' + v.processIdentified + '</option>';
                                                            });
                                                            $("#ddlProcess").append(html);
                                                        })
                                                        $("#divDdlProcess").show();
                                                    }
                                                    else {
                                                        $("#ddlProcess").html('<option value="0">Select Process</option>');
                                                    }
                                                    $(".details_process").hide();
                                                }
                                                function GetDCEnablerScore(select) {
                                                    var processId = parseInt($(select).val());
                                                    var desc = $(select).find('option:selected').attr('id');
                                                    if (processId > 0) {
                                                        $('#DCScore').show();
                                                        $('#ProDes').val(desc);
                                                        $('#FinalScore').show();
                                                        $('#EnablerScore').show();
                                                        $(".details_process").show();
                                                        $('#DCScore').find('input').val(0);
                                                        var model = {
                                                            ParentOrgId: $('#Id').val(),
                                                            ChildOrgId: $('#ChildOrgId').val(),
                                                            FunctionId: $('#FunctionId').val(),
                                                            ProcessId: processId,
                                                            ConCatId: 0,
                                                            AnswerId: 0
                                                        }
                                                        var riskDomainIds = [], parameterIds = [], parameters = [], tbody = '', sn = 0,
                                                            theadDC = '<th width="250px">Parameters</th>', theadES = '<th width="250px">Enablers</th>';
                                                        $.post('/ApplicationManagement/ProcessesAssign/GetDomainCriticalityScoreByProcessId', { model: model }, function (res) {
                                                            $.each(res, function (i, item) {
                                                                if (!riskDomainIds.includes(item.riskDomainId)) {
                                                                    riskDomainIds[i] = item.riskDomainId;
                                                                    theadDC += '<th width="250px">' + item.riskDomain + '</th>';
                                                                    theadES += '<th width="250px">' + item.riskDomain + '</th>';
                                                                }
                                                                if (!parameterIds.includes(item.parameterId)) {
                                                                    parameterIds[sn] = item.parameterId;
                                                                    parameters[sn] = {
                                                                        ParameterId: item.parameterId,
                                                                        Parameter: item.parameter
                                                                    }
                                                                    sn++;
                                                                }
                                                            })
                                                            $.each(parameters, function (i, prm) {
                                                                bgColour = (i == (parameters.length - 1)) ? 'class="parameter" style="font-weight:bolder;font-size:15px;color:teal;"' : 'class="parameter"';
                                                                tbody += '<tr><td ' + bgColour + ' id="' + prm.ParameterId + '">' + prm.Parameter + '</td>';
                                                                $.each(res.filter(function (ele) { return ele.parameterId == prm.ParameterId }), function (i, scr) {
                                                                    tbody += '<td class="parameter' + prm.ParameterId + ' RD_' + scr.riskDomainId + '">' + scr.score + '</td>'
                                                                })
                                                                tbody += '</tr>';
                                                            })
                                                            $('#DomainCritical thead tr').html(theadDC);
                                                            $('#tblEnablerScore thead tr').html(theadES);
                                                            $('#DomainCritical tbody').html(tbody);
                                                        })
                                                        $.post('/ApplicationManagement/ProcessesAssign/GetControlCatByProcessId', { model: model }, function (data) {
                                                            var ConCatIds = [], ControlCategories = [], array = [], tdEnabler = '', sn = 0;
                                                            if (data.length > 0) {
                                                                $.each(data, function (i, item) {
                                                                    if (!ConCatIds.includes(item.value)) {
                                                                        ConCatIds[sn] = item.value;
                                                                        ControlCategories[sn] = {
                                                                            ConCatId: item.value,
                                                                            ConCatName: item.name
                                                                        }
                                                                        sn++;
                                                                    }
                                                                })
                                                                array = data;
                                                            }
                                                            var t1 = 0, t2 = 0, t3 = 0, t4 = 0, t5 = 0, l1 = 0, l2 = 0, l3 = 0, l4 = 0, l5 = 0, length = 0;
                                                            setTimeout(function () {
                                                                $.each(ControlCategories, function (i, ControlCategory) {
                                                                    var s1 = 0, s2 = 0, s3 = 0, s4 = 0, s5 = 0, td = '';
                                                                    $.each(array.filter(function (ele) { return ele.value == ControlCategory.ConCatId }), function (i, item) {
                                                                        model.ConCatId = item.value, model.AnswerId = item.answerId;
                                                                        $.post('/ApplicationManagement/ProcessesAssign/GetDomainBaseRiskScore', { model: model }, function (res) {
                                                                            if (res.length > 0) {
                                                                                debugger;
                                                                                var v1 = res.filter(function (ele) { return ele.domainId == 1 });
                                                                                var v2 = res.filter(function (ele) { return ele.domainId == 2 });
                                                                                var v3 = res.filter(function (ele) { return ele.domainId == 3 });
                                                                                var v4 = res.filter(function (ele) { return ele.domainId == 4 });
                                                                                var v5 = res.filter(function (ele) { return ele.domainId == 5 });
                                                                                s1 += parseFloat(v1[0].score); s2 += parseFloat(v2[0].score); s3 += parseFloat(v3[0].score); s4 += parseFloat(v4[0].score); s5 += parseFloat(v5[0].score);
                                                                                l1 += parseFloat(v1[0].score) > 0 ? 1 : 0; l2 += parseFloat(v2[0].score) > 0 ? 1 : 0; l3 += parseFloat(v3[0].score) > 0 ? 1 : 0; l4 += parseFloat(v4[0].score) > 0 ? 1 : 0; l5 += parseFloat(v5[0].score) > 0 ? 1 : 0;
                                                                            }
                                                                        })
                                                                    })
                                                                    setTimeout(function () {
                                                                        td += '<td class="ConCat' + ControlCategory.ConCatId + ' RD_1">' + s1 + '</td>';
                                                                        td += '<td class="ConCat' + ControlCategory.ConCatId + ' RD_2">' + s2 + '</td>';
                                                                        td += '<td class="ConCat' + ControlCategory.ConCatId + ' RD_3">' + s3 + '</td>';
                                                                        td += '<td class="ConCat' + ControlCategory.ConCatId + ' RD_4">' + s4 + '</td>';
                                                                        td += '<td class="ConCat' + ControlCategory.ConCatId + ' RD_5">' + s5 + '</td>';
                                                                        tdEnabler += '<tr><td class="ConCat" id="' + ControlCategory.ConCatId + '">' + ControlCategory.ConCatName + '</td>' + td + '</tr>';
                                                                        t1 += s1, t2 += s2, t3 += s3, t4 += s4, t5 += s5;
                                                                        length++;
                                                                    }, 500)
                                                                })
                                                            }, 300)
                                                            setTimeout(function () {

                                                                tdEnabler += '<tr>' +
                                                                    '<td class="ConCat" id="0" style="font-weight:bolder;font-size:15px;color:teal;">Base Residual Risk Score</td>' +
                                                                    '<td class="ConCat0 RD_1">' + parseFloat(isNaN(t1 / l1) ? 0 : (t1 / l1)) + '</td>' +
                                                                    '<td class="ConCat0 RD_2">' + parseFloat(isNaN(t2 / l2) ? 0 : (t2 / l2)) + '</td>' +
                                                                    '<td class="ConCat0 RD_3">' + parseFloat(isNaN(t3 / l3) ? 0 : (t3 / l3)) + '</td>' +
                                                                    '<td class="ConCat0 RD_4">' + parseFloat(isNaN(t4 / l4) ? 0 : (t4 / l4)) + '</td>' +
                                                                    '<td class="ConCat0 RD_5">' + parseFloat(isNaN(t5 / l5) ? 0 : (t5 / l5)) + '</td></tr>';
                                                                $('#tblEnablerScore tbody').html(tdEnabler);
                                                            }, 1000)
                                                            setTimeout(function () {
                                                                var f1 = 0, f2 = 0, f3 = 0, f4 = 0, f5 = 0;
                                                                var DCS = $('#DomainCritical tbody tr:last td').each(function (i, ele) { });
                                                                var BRRS = $('#tblEnablerScore tbody tr:last td').each(function (i, ele) { });
                                                                f1 += parseFloat(parseFloat($(DCS[1]).text()) * parseFloat($(BRRS[1]).text())).toFixed(2);
                                                                f2 += parseFloat(parseFloat($(DCS[2]).text()) * parseFloat($(BRRS[2]).text())).toFixed(2);
                                                                f3 += parseFloat(parseFloat($(DCS[3]).text()) * parseFloat($(BRRS[3]).text())).toFixed(2);
                                                                f4 += parseFloat(parseFloat($(DCS[4]).text()) * parseFloat($(BRRS[4]).text())).toFixed(2);
                                                                f5 += parseFloat(parseFloat($(DCS[5]).text()) * parseFloat($(BRRS[5]).text())).toFixed(2);
                                                                $('#DCFinalScore').text(f1), $('#CSFinalScore').text(f2), $('#DIFinalScore').text(f3), $('#AvailabilityFinalScore').text(f4), $('#PrivacyScore').text(f5);
                                                                $('.action').eq(0).text(f1 < 5 ? 'Accept' : f1 >= 5 && f1 < 12 ? 'Management Decision' : 'Treat').css('background-color', f1 < 5 ? 'green' : f1 >= 5 && f1 < 12 ? 'orange' : 'red').css('color', 'white');
                                                                $('.action').eq(1).text(f2 < 5 ? 'Accept' : f2 >= 5 && f2 < 12 ? 'Management Decision' : 'Treat').css('background-color', f2 < 5 ? 'green' : f2 >= 5 && f2 < 12 ? 'orange' : 'red').css('color', 'white');
                                                                $('.action').eq(2).text(f3 < 5 ? 'Accept' : f3 >= 5 && f3 < 12 ? 'Management Decision' : 'Treat').css('background-color', f3 < 5 ? 'green' : f3 >= 5 && f3 < 12 ? 'orange' : 'red').css('color', 'white');
                                                                $('.action').eq(3).text(f4 < 5 ? 'Accept' : f4 >= 5 && f4 < 12 ? 'Management Decision' : 'Treat').css('background-color', f4 < 5 ? 'green' : f4 >= 5 && f4 < 12 ? 'orange' : 'red').css('color', 'white');
                                                                $('.action').eq(4).text(f5 < 5 ? 'Accept' : f5 >= 5 && f5 < 12 ? 'Management Decision' : 'Treat').css('background-color', f5 < 5 ? 'green' : f5 >= 5 && f5 < 12 ? 'orange' : 'red').css('color', 'white');
                                                            }, 1500)
                                                        })
                                                    } else {
                                                        $('#DCScore').hide();
                                                        $('#FinalScore').hide();
                                                        $('#EnablerScore').hide();
                                                        $(".details_process").hide();
                                                        $('#DCScore').find('input').val(0);
                                                    }
                                                }
                                            </script>
                                            <table id="tblEnablerScore" class="table"><thead><tr></tr></thead><tbody></tbody></table>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div id="FinalScore" style="display:none;">
                                <div class="pb-2 mb-2 border-bottom box_title">
                                    Final Score
                                </div>
                                <div class="row">
                                    <div class="col-12">
                                        <div class="table_control">
                                            <table class="table table-bordered">
                                                <tbody>
                                                    <tr>
                                                        <td width="250px" style="font-weight: bolder; font-size: 15px; color: teal;">Final Risk Score</td>
                                                        <td width="250px" class="FRS FRS_1" id="DCFinalScore">0</td>
                                                        <td width="250px" class="FRS FRS_2" id="CSFinalScore">0</td>
                                                        <td width="250px" class="FRS FRS_3" id="DIFinalScore">0</td>
                                                        <td width="250px" class="FRS FRS_4" id="AvailabilityFinalScore">0</td>
                                                        <td width="250px" class="FRS FRS_5" id="PrivacyScore">0</td>
                                                    </tr>
                                                    <tr>
                                                        <td>Action</td>
                                                        <td class="action"></td>
                                                        <td class="action"></td>
                                                        <td class="action"></td>
                                                        <td class="action"></td>
                                                        <td class="action"></td>
                                                    </tr>
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                                <script>
                                    function CalculateFinalScore(input) {
                                        var DCAvg = parseFloat($('#DCAvg').text())
                                        var CSAvg = parseFloat($('#CSAvg').text())
                                        var DIAvg = parseFloat($('#DIAvg').text())
                                        var AvailabilityAvg = parseFloat($('#AvailabilityAvg').text())
                                        var PrivacyAvg = parseFloat($('#PrivacyAvg').text())

                                        var DCValue = parseFloat($('#DCAverage').val())
                                        var CSValue = parseFloat($('#CSAverage').val())
                                        var DIValue = parseFloat($('#DIAverage').val())
                                        var AvbValue = parseFloat($('#AvailabilityAverage').val())
                                        var PrivacyValue = parseFloat($('#PrivacyAverage').val())

                                        $('#DCFinalScore').text((DCAvg * DCValue).toFixed(2))
                                        $('#CSFinalScore').text((CSAvg * CSValue).toFixed(2))
                                        $('#DIFinalScore').text((DIAvg * DIValue).toFixed(2))
                                        $('#AvailabilityFinalScore').text((AvailabilityAvg * AvbValue).toFixed(2))
                                        $('#PrivacyScore').text((PrivacyAvg * PrivacyValue).toFixed(2))
                                    }
                                </script>
                            </div>
                            <div class="row">
                                <div class="col-md-12 col-sm-6 col-xs-12">
                                    <div class="back_btn">
                                        <div class="back_btn_in">
                                            <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                        </div>
                                    </div>
                                    <div class="submitbtn">
                                        <input type="button" id="btnsubmit" name="Submit" value="Submit" onclick="prepareValueForSave()">
                                        <input type="reset" id="reset" value="reset" hidden />
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">SN</th>
                                                <th>Parent Organization Name</th>
                                                <th>Corporate Office Location</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        @{int sn = 0;}
                                        @foreach (var item in Model.OrganizationList)
                                        {
                                            <tr>
                                                <td>@(++sn)</td>
                                                <td>@item.ParentOrgName</td>
                                                <td>@item.CorporateOfficeLocation</td>
                                                <td>
                                                    <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-parentOrgId="@item.Id" asp-controller="ProcessesAssign" asp-area="ApplicationManagement" class="edit_btn"></a>
                                                    @*<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="BlockDeleteOrganization" asp-route-Id="@item.Id" asp-route-Type="0" asp-controller="Organization" asp-area="ApplicationManagement" class="Active_btn" asp-route-ActionName="@(item.IsActive ? "InActive" : "Active")"></a>*@
                                                    @*<a class="delete_btn" onclick="Confirmation('@item.Id')"></a>*@
                                                </td>
                                            </tr>
                                        }
                                        <tbody>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<script type="text/javascript">
    function Fn_Edit(id) {
        $.ajax({
            url: "/ApplicationManagement/ProcessesAssign/GetProcessesByOrgId",
            type: "GET",
            cache: false,
            data: { Id: id },
            success: function (res) {
                $("#ddlProcess").empty();
                $("#processInput").empty();
                var html = '<option value="0">Select Process</option>';
                var inputhtml = '';
                $.each(res, function (i, v) {
                    html += '<option value="' + v.id + '" id="' + v.description + '">' + v.processIdentified + '</option>';
                    inputhtml += '<input type="hidden" id="PD' + v.id + '" value="' + v.description + '">';
                });
                $("#ddlProcess").append(html);
                $("#processInput").append(inputhtml);
                $('#Id').val(id);
                showForm();
            }
        });
    }
    function showForm() {
        $('#dvDataTable').hide();
        $('#dvForm').removeAttr('class');
    }
    function hideForm() {
        $('#reset').click();
        $('#dvDataTable').show();
        $('#dvForm').attr('class', 'service_line');
    }
    //$("input[type=submit]").click(function () {
    //    if ($("select[name=OrganizationId]").val() == "" && $("select[name=OrganizationId]").val() == 0) {
    //        toastr.error("select organization name");
    //        return false;
    //    } else if ($("select[name=CategoryId]").val() == null) {
    //        toastr.error("select a category name");
    //        return false;
    //    } else if ($("select[name=ChildOrgId]").val() == 0) {
    //        toastr.error("select child organization name");
    //        return false;
    //    }
    //})
    function prepareValueForSave() {
        var clientProcessDCScoreXML = [], clientProcessEnablerScoreXML = [], clientProcessFinalScoreXML = [];
        var parentOrgId = parseInt($('#Id').val());
        var childOrgId = parseInt($('#ChildOrgId').val());
        var functionId = parseInt($('#FunctionId').val());
        var processId = parseInt($('#ddlProcess').val());
        $('.parameter').each(function (pI, pEle) {
            var parameterId = parseInt($(pEle).attr('id'));
            var domainScore = [];
            $('.parameter' + parameterId).each(function (dI, dEle) {
                var riskDomainId = parseInt($(dEle).attr('class').split(' ')[1].split('_')[1]);
                var score = parseFloat($(dEle).text());
                domainScore[dI] = {
                    RiskDomainId: riskDomainId,
                    Score: score
                }
            })
            clientProcessDCScoreXML[pI] = {
                ParameterId: parameterId,
                RiskDomainScore: domainScore
            }
        })
        $('.ConCat').each(function (pI, pEle) {
            var conCatId = parseInt($(pEle).attr('id'));
            var domainScore = [];
            $('.ConCat' + conCatId).each(function (dI, dEle) {
                var riskDomainId = parseInt($(dEle).attr('class').split(' ')[1].split('_')[1]);
                var score = parseFloat($(dEle).text());
                domainScore[dI] = {
                    RiskDomainId: riskDomainId,
                    Score: score
                }
            })
            clientProcessEnablerScoreXML[pI] = {
                ConCatId: conCatId,
                RiskDomainScore: domainScore
            }
        })
        $('.FRS').each(function (i, ele) {
            var riskDomainId = parseInt($(ele).attr('class').split(' ')[1].split('_')[1]);
            var score = parseFloat($(ele).text());
            clientProcessFinalScoreXML[i] = {
                RiskDomainId: riskDomainId,
                Score: score
            }
        })
        var model = {
            ParentOrgId: parentOrgId,
            ChildOrgId: childOrgId,
            FunctionId: functionId,
            ProcessId: processId,
            ClientProcessDCScoreXML: JSON.stringify(clientProcessDCScoreXML),
            ClientProcessEnablerScoreXML: JSON.stringify(clientProcessEnablerScoreXML),
            ClientProcessFinalScoreXML: JSON.stringify(clientProcessFinalScoreXML)
        }
        $.post('/ApplicationManagement/ProcessesAssign/SubmitDCEnablerFinalScore', { model: model }, function (res) {
            $('a[href="/ApplicationManagement/ProcessesAssign/Index"]').click();
            res.isSuccess ? toastr.error('Something went wrong!') : toastr.success('Saved successfully.');
        })
    }
    function fn_GetQuestionnaire(select) {
        $("#que").removeClass("hidden");
        $("#dvmultiTable").empty();
        $('#CategoryId option:selected').each(function (i) {
            var CategoryId = $(this).val();
            var CategoryText = $(this).text();
            if (CategoryId == 'multiselect-all') {
                $("#dvmultiTable").empty();
                return;
            }
            var html = '<table class="table" id="tbl_' + CategoryId + '"><thead><tr>';
            $.get('/ApplicationManagement/Compliance/GetQuestionnaireById', { CategoryId: CategoryId }, function (data) {
                html += '<th colspan="' + parseInt(data.length + 2) + '">' + CategoryText + '</th></tr>';
                html += '<tr><th name="0">SN</th>';
                $.each(data, function (i, value) {
                    html += '<th name=' + value.id + '>' + value.query + '</th>';
                });
                html += '<th name="0">Action</th></tr></thead><tbody><tr><td>1</td>';
                $.each(data, function (i, value) {
                    html += '<td><input type="text" class="form-control ques' + value.id + '" /></td>';
                });
                html += '<td><input type="button" class="btn btn-info" value="Add" onclick="AddMoreAnswers(this)"/></td></tr></tbody></table>';
                $("#dvmultiTable").append(html);
            });
        });
        if ($("select[name=CategoryId]").val() == null) {
            $("#que").addClass("hidden");
        }
    }
    function AddMoreAnswers(input) {
        var tdLength = $(input).closest('tr').find('td').length;
        var sn = parseInt($(input).closest('tbody').find('tr:last td:eq(0)').text()) + 1;
        var html = '<tr><td>' + sn + '</td>';
        for (var i = 0; i < tdLength; i++) {
            if (i == 0 || i == tdLength - 1) { continue; }
            html += '<td>';
            html += $(input).closest('tbody').find('tr:first td').eq(i).html();
            html += '</td>';
        }
        html += '<td><input type="button" class="btn btn-danger" value="Remove" onclick="RemoveMoreAnswers(this)"></td></tr>';
        $(input).closest('tbody').append(html);
    }
    function RemoveMoreAnswers(input) {
        $(input).closest('tr').remove();
    }
    function fnUpdate(Id, CountryId, ControlCategory, Query) {
        showForm()
        $('#Id').val(Id);
        $('#CountryId').val(CountryId);
        $('#ControlCategory').val(ControlCategory);
        $('#Query').val(Query);
        $('#EventType').val(1);
    }
    function fnBlockDelete(Id, Action, Type) {
        if (confirm('Are you sure you want to ' + Action + ' this Assesment?')) {
            $.get('/ApplicationManagement/Assesment/BlockDeleteAssesment', { Id: Id, EventType: Type }, function (data) {
                if (data.code == 200) {
                    toastr.success(Action + ' successfully');
                    $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                } else {
                    toastr.error('Something went wrong!');
                }
            });
        }
    }
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this assesment',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Assesment/BlockDeleteAssesment",
                    type: "POST",
                    cache: false,
                    data: { Id: id, EventType: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
    function fn_Activeincative(id, status) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to ' + status + ' this assesment',
            showCancelButton: true,
            confirmButtonText: status,
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/ApplicationManagement/Assesment/BlockDeleteAssesment",
                    type: "POST",
                    cache: false,
                    data: { Id: id, EventType: Type = 0 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success(status + " " + "successfully!!");
                        $('a[href="/ApplicationManagement/Assesment/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>